package org.netkernel.rdf.jena.endpoint;

import java.io.ByteArrayOutputStream;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.NKFException;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;
import org.netkernel.rdf.jena.rep.IRepJenaModel;
import org.netkernel.rdf.jena.rep.JenaModelRepresentation;

import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;

public class DefaultModelParser extends StandardTransreptorImpl
{
	public DefaultModelParser()
	{
		this.declareThreadSafe();
		this.declareToRepresentation(IRepJenaModel.class);
		this.declareFromRepresentation(IReadableBinaryStreamRepresentation.class);
	}

	@Override
	public void onTransrept(INKFRequestContext context) throws Exception
	{	IReadableBinaryStreamRepresentation rbs=context.sourcePrimary(IReadableBinaryStreamRepresentation.class);
		Model m=ModelFactory.createDefaultModel();
		try
		{	m.read(rbs.getInputStream(), context.getThisRequest().getIdentifier());
		}
		catch(Exception e)
		{	throw new NKFException("Default RDF Parse failed - are you sure this is XML/RDF?", e.getMessage(), e);			
		}
		context.createResponseFrom(new JenaModelRepresentation(m));
	}
}
